close all;

Prefix = fPrefix();
PathPrefix = strcat('..\',Prefix);

if ~exist('ArduinoInputsDetects','var')
    [~,~,ArduinoInputsDetects] = xlsread(strcat(PathPrefix, '.Log.xlsx'));
end

%ReportFileID = fopen(strcat(PathPrefix,'.Validation.csv'),'w');

LineTypeC = 2;
SampleNoC = 3;
AdjIC = 4;
AdjQC = 5;
CutC = 6;
IsDispC = 7;
IsConfC = 8;

VideoOffsetC = 11;

SnippetSize = 250;
RotationLength = 5.6 / 2; % cm

SampleNoInit = ArduinoInputsDetects{2,SampleNoC};
VideoOffset = ArduinoInputsDetects{2,VideoOffsetC};

% Unwraps = nan(length(ArduinoInputsDetects),6);
% SampleNoUnC = 1;
% AdjIUnC = 2;
% AdjQUnC = 3;
% AngleDiffUnC = 4;
% CumAngleDiffUnC = 5;
% IsCutUnC = 6;
% 
% CumDistance = 0;

CumCuts = 0;

PlotArr = nan(length(ArduinoInputsDetects),4);
SampleNoNanC = 1;
CumCutsNanC = 2;
IsDispNanC = 3;
IsConfNanC = 4;


for Idx = 1 : length(ArduinoInputsDetects)
    if ~strcmp(ArduinoInputsDetects(Idx, LineTypeC), '#5') || isnan(ArduinoInputsDetects{Idx+1,1})
        continue;
    end
    
    SampleNo = ArduinoInputsDetects{Idx, SampleNoC};
    Cut = ArduinoInputsDetects{Idx, CutC};
    IsDisp = ArduinoInputsDetects{Idx, IsDispC};
    IsConf = ArduinoInputsDetects{Idx, IsConfC};
    
    CumCuts = CumCuts + Cut;
    
    if Cut ~= 0;
    end;
    
    PlotArr(Idx,SampleNoNanC) = SampleNo - SampleNoInit;
    PlotArr(Idx,CumCutsNanC) = CumCuts;
    PlotArr(Idx,IsDispNanC) = IsDisp;
    PlotArr(Idx,IsConfNanC) = IsConf;
    
%     if SampleNo < SampleNoInit + 1
%          continue;
%      end;
     
%      AdjIA = ArduinoInputsDetects{Idx, AdjIC};
%      AdjQA = ArduinoInputsDetects{Idx, AdjQC};
%      PrevAdjIA = ArduinoInputsDetects{Idx-1, AdjIC};
%      PrevAdjQA = ArduinoInputsDetects{Idx-1, AdjQC};
    
%     % Do the unwrap            
%     
%     PrevAngle = atan2(PrevAdjIA, PrevAdjQA);
%     Angle = atan2(AdjIA, AdjQA);
%     Diff = angleDiff(PrevAngle, Angle);
%     if round(mod(Diff,pi),5) == 0
%         Diff = 0;
%     end
%     
%     %(Diff / (2*pi)) * RotationLength
% 
%     % Sample Number
%     Unwraps(Idx, SampleNoUnC) = SampleNo;
%     % Sample vals
%     Unwraps(Idx, AdjIUnC) = AdjIA;
%     Unwraps(Idx, AdjQUnC) = AdjQA;
%     % Diff
%     Unwraps(Idx, AngleDiffUnC) = Diff;
%     % Cum Diff
%     if Idx == 1 || isnan(Unwraps(Idx-1,AngleDiffUnC))
%         PrevCumDiff = 0;
%     else
%         PrevCumDiff = Unwraps(Idx-1, CumAngleDiffUnC);
%     end
%     Unwraps(Idx, CumAngleDiffUnC) = PrevCumDiff + Unwraps(Idx, AngleDiffUnC);
%     % Is Cut
%     Unwraps(Idx, IsCutUnC) = ArduinoInputsDetects{Idx,IsCutC};
    
%     IsCutM = 0;
%     
%     % Clockwise: See if going from negative to positive
%     if Diff < 0 && PrevAdjIA < 0 && AdjIA > 0
%         IsCutM = +1;
%     end
%     
%     % Counter-clockwise: See if going from positive to negative
%     if Diff > 0 && PrevAdjIA > 0 && AdjIA < 0
%         IsCutM = -1;
%     end
%     
%     if IsCutM ~= IsCutA
%         Msg = sprintf('Cut Error. Sample No: %i, Arduino: %i; MatLab: %i\n', SampleNo, IsCutA, IsCutM);
%         fprintf(Msg); fprintf(ReportFileID, Msg);
%         CutErrors = CutErrors + 1;
%         
%         Cross = (PrevAdjQA * AdjIA) - (PrevAdjIM * AdjQA);
%         Msg = sprintf('SampNo: %i\n', SampleNo);
%         
%         fprintf(Msg); fprintf(ReportFileID, Msg);
%         Msg = sprintf('Prev (I,Q) Ard: (%i,%i)\n',PrevAdjIA, PrevAdjQA);
%         
%         Msg = sprintf(Msg); fprintf(ReportFileID, Msg);
%         fprintf(Msg); fprintf(ReportFileID, Msg);
%         
%         Msg = sprintf('Prev (I,Q): (%i,%i); Angle: %2f\n',PrevAdjIA, PrevAdjQA, rad2deg(PrevAngle));
%         fprintf(Msg); fprintf(ReportFileID, Msg);
% 
%         Msg = sprintf('Curr (I,Q): (%i,%i); Angle: %2f\n',AdjIA, AdjQA, rad2deg(Angle));
%         fprintf(Msg); fprintf(ReportFileID, Msg);
%         
%         Msg = sprintf('Diff: %2f, Cross: %i\n\n', rad2deg(Diff), Cross);
%         fprintf(Msg); fprintf(ReportFileID, Msg);
%         
%         figure;
%         plot(PrevAdjQA, PrevAdjIA, '+', AdjQA, AdjIA, '*', 0, 0, 'o');
%         MaxX = max(abs(PrevAdjQM),abs(AdjQA)) + 1;
%         xlim([-MaxX, MaxX]);
%         MaxY = max(abs(PrevAdjIM),abs(AdjIA)) + 1;
%         ylim([-MaxY, MaxY]);
%         
%     end
%     
    %CurrCutsM = CurrCutsM + IsCutA;
    
    
end

PlotArr = PlotArr(~isnan(PlotArr(:,SampleNoNanC)),:);

TickSpacing = 10;
TickLimit = max(PlotArr(:,SampleNoNanC)/250);

figure('units','normalized','outerposition',[0 0 1 1]);

Index = (PlotArr(:,SampleNoNanC)/250)+VideoOffset;

subplot(6,1,1:4);
plot(Index,PlotArr(:,CumCutsNanC)*RotationLength,'b');
ax = gca;
%ax.XTick = 0:TickSpacing:TickLimit;

subplot(6,1,5);
plot(Index,PlotArr(:,IsDispNanC),'g');
ylim([-.5 1.5]);
ax = gca;
%ax.XTick = 0:TickSpacing:TickLimit;

subplot(6,1,6);
plot(Index,PlotArr(:,IsConfNanC),'r');
ylim([-.5 1.5]);
ax = gca;
%ax.XTick = 0:TickSpacing:TickLimit;

%fclose(ReportFileID);